#pragma once

#include "CoreMinimal.h"
#include "DBDActorIndicator.h"
#include "K38AimAssistObjectiveInfo.h"
#include "K38ObjectiveAimAssistTarget.generated.h"

class AActor;
class AKiller;

UCLASS(Blueprintable)
class AK38ObjectiveAimAssistTarget : public ADBDActorIndicator
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float _scanForObjectivesPeriod;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float _acquisitionAngle;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float _releaseAngle;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float _objectiveCenteringHeightMultiplier;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TArray<FK38AimAssistObjectiveInfo> _pointsOfInterest;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FName _jointCrankTargetName;

private:
	UFUNCTION(BlueprintCallable, Server, Reliable, WithValidation)
	void Server_SetSelectedObjective(AActor* newSelectedObjective);

	UFUNCTION(BlueprintCallable, NetMulticast, Reliable, WithValidation)
	void Multicast_SetSelectedObjective(AActor* newSelectedObjective);

protected:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_OnAimAssistObjectiveSelected(AActor* selectedObject, AKiller* killer);

public:
	AK38ObjectiveAimAssistTarget();
};

FORCEINLINE uint32 GetTypeHash(const AK38ObjectiveAimAssistTarget) { return 0; }
